----------------------------------------------
--		Serenity Now						--
--			By Shampow on US-Archimonde		--
----------------------------------------------

SN = LibStub("AceAddon-3.0"):NewAddon("SerenityNow", "AceEvent-3.0", "AceTimer-3.0",  "AceConsole-3.0")
SN.ver = "r17"

SN.LSM = LibStub("LibSharedMedia-3.0")

SN.timers = LibStub("LibFancyBar-1.0")

SN.F = {} 	-- Frames
SN.V = LibStub("AceDB-3.0"):New("SNDB", defaults, true)
SN_UpdateInterval = 1.0 -- How often the OnUpdate code will run (in seconds)

function SN:OnEnable()
	
end


function SN:OnInitialize()

	if count == 1 then return end

	print(format("Welcome to Serenity Now...Just take a deep breath."))
	
	SN:RegisterChatCommand("sn", "Cmds")

	--Check to see if ElvUI is loaded so we can make the bars purty
	if (IsAddOnLoaded("ElvUI")) then
		local E, L, V, P, G, _ = unpack(ElvUI)
	end

	--Timer Groups
	SN:Debuffs()
	SN:CoolDowns()
	
	--Setup Power Bar
	SN:SetupPower()
	SN:RegisterEvent("UNIT_DISPLAYPOWER", "UpdatePowerType")

	collectgarbage("collect")
	count = 1
end

function SN:Cmds(input)

	local v1, v2 = input:match("^(%S*)%s*(.-)$")
	v1 = v1:lower()

	if (v1 == "") then	
		print("Serenity Now "..SN.ver)
		print("/sn config - open the config frame.")
		print("/sn lock - unlock/lock the frames.")
		print("/sn reset - reset the frames positions.")
	elseif (v1 == "options") or (v1 == "config") or (v1 == "opt") or (v1 == "o") then

	elseif (v1 == "reset") then
		if (not InCombatLockdown()) then

		else
			print("cannot reset during combat.")
		end
	elseif (v1 == "lock") or (v1 == "unlock") or (v1 == "drag") or (v1 == "move") or (v1 == "l") then
		SN:MoveFrames()
	else
		print("command not known.")
	end
end

function SN:MoveFrames()
	if SN.F.powercontainer:IsShown() then
		if SN.F.powercontainer:IsMovable() then
			SN.F.powercontainer:SetMovable(false)
		else
			SN.F.powercontainer:SetMovable(true)
		end
	end
	
	if SN.F.debuffs:IsMovable() then
		SN.F.debuffs:Lock(true)
	else
		SN.F.debuffs:Lock(false)
	end
	
	if SN.F.cooldowns:IsMovable() then
		SN.F.cooldowns:Lock(true)
	else
		SN.F.cooldowns:Lock(false)
	end
end